---
title: FileSystemHandle.requestPermission()
slug: Web/API/FileSystemHandle/requestPermission
tags:
  - Directory
  - File
  - File System Access API
  - FileSystemHandle
  - Method
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("File System Access API")}}</div>

<p class="summary">The <strong><code>requestPermission()</code></strong> method of the {{domxref("FileSystemHandle")}} interface requests read or readwrite permissions for the file handle.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>PermissionState</var> = FileSystemHandle.requestPermission(FileSystemHandlePermissionDescriptor);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>FileSystemHandlePermissionDescriptor {{optional_inline}}</dt>
 <dd>An object which specifies the permission mode to query for. Options are as follows:
 <ul>
  <li><code>'mode'</code>: Can be either <code>'read'</code> or <code>'readwrite'</code>.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{domxref('PermissionStatus.state')}} which is one of <code>'granted'</code>, <code>'denied'</code> or <code>'prompt'</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>TypeError</code></dt>
 <dd>No parameter is specified or the <code>mode</code> is not that of <code>'read'</code> or <code>'readwrite'</code></dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following asynchronous function requests permissions if they have not been granted.</p>

<pre class="brush: js notranslate">// fileHandle is a FileSystemFileHandle
// withWrite is a boolean set to true if write

async function verifyPermission(fileHandle, withWrite) {
  const opts = {};
  if (withWrite) {
    opts.mode = 'readwrite';
  }

  // Check if we already have permission, if so, return true.
  if (await fileHandle.queryPermission(opts) === 'granted') {
    return true;
  }

  // Request permission to the file, if the user grants permission, return true.
  if (await fileHandle.requestPermission(opts) === 'granted') {
    return true;
  }

  // The user did not grant permission, return false.
  return false;
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('File System Access','#api-filesystemhandle-requestpermission','requestPermission')}}</td>
   <td>{{Spec2('File System Access')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemHandle.requestPermission")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/docs/Web/API/File_System_Access_API">File System Access API</a></li>
 <li><a href="https://web.dev/file-system-access/">The File System Access API: simplifying access to local files</a></li>
</ul>
